/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

cordova.define("cordova-plugin-inappbrowser.inappbrowser",function(e,n,r){!function(){function n(){this.channels={loadstart:i.create("loadstart"),loadstop:i.create("loadstop"),loaderror:i.create("loaderror"),exit:i.create("exit")}}if(window.parent&&window.parent.ripple)return void(r.exports=window.open.bind(window));var o=e("cordova/exec"),i=e("cordova/channel"),t=e("cordova/modulemapper"),l=e("cordova/urlutil");n.prototype={_eventHandler:function(e){e&&e.type in this.channels&&this.channels[e.type].fire(e)},close:function(){o(null,null,"InAppBrowser","close",[])},show:function(){o(null,null,"InAppBrowser","show",[])},hide:function(){o(null,null,"InAppBrowser","hide",[])},addEventListener:function(e,n){e in this.channels&&this.channels[e].subscribe(n)},removeEventListener:function(e,n){e in this.channels&&this.channels[e].unsubscribe(n)},executeScript:function(e,n){if(e.code)o(n,null,"InAppBrowser","injectScriptCode",[e.code,!!n]);else{if(!e.file)throw new Error("executeScript requires exactly one of code or file to be specified");o(n,null,"InAppBrowser","injectScriptFile",[e.file,!!n])}},insertCSS:function(e,n){if(e.code)o(n,null,"InAppBrowser","injectStyleCode",[e.code,!!n]);else{if(!e.file)throw new Error("insertCSS requires exactly one of code or file to be specified");o(n,null,"InAppBrowser","injectStyleFile",[e.file,!!n])}}},r.exports=function(e,r,i,c){if(window.frames&&window.frames[r]){var s=t.getOriginalSymbol(window,"open");return s.apply(window,arguments)}e=l.makeAbsolute(e);var a=new n;c=c||{};for(var p in c)a.addEventListener(p,c[p]);var d=function(e){a._eventHandler(e)};return i=i||"",o(d,d,"InAppBrowser","open",[e,r,i]),a}}()});